#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;


my $directory = "C:/Windows";

my $no_files = 0;
my $no_dirs = 0;
my $writable = 0;
my $readable = 0;
my %extensions;


unless (-e $directory) {
	die "Sorry - '$directory' doesn't exist";	
} 

unless  (-d $directory) {
	die "Sorry - '$directory' isn't a directory";
}
	
	
chdir $directory or die "Can't move to $directory: $!";

while (my $file = <*>) {
	if (-f $file) {
		++$no_files;
		++$readable if (-r $file);
		++$writable if (-w $file);
		
		my $ext = lc(substr($file,-3,3));
		++$extensions{$ext};
	}
	elsif (-d $file) {
		++$no_dirs;
	}	
}

print <<"END_REPORT";
Report on $directory

Number of directories:\t$no_dirs

Number of files:\t$no_files
\tReadable:\t$readable
\tWritable:\t$writable


File Breakdown:
END_REPORT

foreach my $ext (sort {$extensions{$b} <=> $extensions{$a}} keys %extensions) {
	print "\t$ext\t$extensions{$ext}\n";	
}


